% Extract the diagonal of the system matrix as a sparse matrix.
%
% function M = diag(self)
%
function M = diag(self)
    if ~self.initialized
        error('Matrix not initialized');
    else
        neqns = size(self.mat,1);
        M = sparse((1:neqns),(1:neqns),diag(self.mat));
    end
end
