function cookstrain_compare
    graphics= ~true;
    doeig=~true;
    aspect=1;
    smult=0;
    %     nu =1/2*lambda/(G+lambda)
    nu= 0.4998;
    %     E=G*(3*lambda+2*G)/(G+lambda);
    E=240.565;%MPa
    nus = [(1-2.^(-(1:10)))*nu,(1:100)*0+nu];
    % nus = [(1:100)*0+nu];
    magn =100/16;
    nincr = 3;
    % Data: Elguedj et al. CMAME 2008
    %     
    convutip=6.9083;% for 128x128 mesh
   

%     if ~graphics
%         loglog(refh,Q4refuerr,'ko:','lineWIDTH', 3); hold on;
%         loglog(refh,T3refuerr,'k<:','lineWIDTH', 3); hold on;
%     end

%         NICE-H8
%    22.0000   11.0000    5.5000    2.7500    1.3750
%     2.7564    4.9692    6.2023    6.6380    6.8048
%     Meshf=@block; ne=[2,4,8,16,32];
%     Convertf=[];
%     integration_rule =tensprod_nq_rule(struct('dim',3,'order',1));
%     Edge_integration_rule =tensprod_nq_rule(struct('dim',2,'order',1));
%     febf =@feblock_defor_nonlinear_nice;
%     Style ='md-'; Label='NICE-H8';

    
    
    Meshf=@block;  ne=[6];
    Convertf=@H8_to_H64;
    integration_rule =tensprod_nq_rule(struct('dim',3,'order',3));
    Edge_integration_rule =tensprod_nq_rule(struct('dim',2,'order',3));
    febf =@feblock_defor_nonlinear_nice;
    Style ='md-'; Label='NICE-H64';

%     Meshf=@block; ne=[1,2,4,8];
%     Convertf=@H8_to_H64;
%     integration_rule =gauss_rule(3,4);
%     Edge_integration_rule =gauss_rule(2,2);
%     febf =@feblock_defor_nonlinear;
%     Style ='md-'; Label='H64';


%     Meshf=@block; ne=[12];
%     Convertf=@H8_to_H27;
%     integration_rule =tensprod_nq_rule(struct('dim',3,'order',2));
%     Edge_integration_rule =tensprod_nq_rule(struct('dim',2,'order',2));
%     febf =@feblock_defor_nonlinear_nice;
%     Style ='md-'; Label='NICE-H27';

%     Meshf=@block; ne=[16];
%     Convertf=@H8_to_H27;
%     integration_rule =gauss_rule(3,3);
%     Edge_integration_rule =gauss_rule(2,2);
%     febf =@feblock_defor_nonlinear;
%     Style ='kd-'; Label='H27';

%     Meshf=@t4block; ne=[2,4,8,16];
%     Convertf=[];
%     integration_rule =simplex_nq_rule(struct('dim',3,'order',1));
%     Edge_integration_rule =simplex_nq_rule(struct('dim',2,'order',1));
%     febf =@feblock_defor_nonlinear_nice;
%     Style ='rh-'; Label='NICE-T4';

%     Meshf=@block; ne=[4,8,16,32];
%     Convertf=[];
%         integration_rule = tensprod_nq_rule(struct('dim',3,'order',1));
%     Edge_integration_rule =tensprod_nq_rule(struct('dim',2,'order',1));
%        febf =@feblock_defor_;
%         Style ='gs-'; Label='Q4-SRI';

%         Meshf=@block; ne=[4,8,16,32];
%     Convertf=[];
%         integration_rule = gauss_rule(3,2);
%          Edge_integration_rule =gauss_rule(2,2);
%         febf =@feblock_defor_nonlinear;
%         Style ='gs-'; Label='H8';



    % OPT element (Felippa)
    %     loglog(44./[2, 4, 8, 16, 32, 64],(convutip-[20.56, 22.45, 23.43, 23.80, 23.91, 23.95])/convutip,'ko:','lineWIDTH', 2); hold on; figure (gcf); pause (1)

    % Mesh
    h=[];
    utip=[];
     
    %     for n=[4,8,16,32]
    for n=ne
        % for n=[2,4,8,16,32,64,128]
        %             for n=[2,4,8,16,24,32,64,128]
        %         for n=[4]
        options =struct('other_dimension', 1.0);
        [fens,gcells] = Meshf(48,44,1.0, n, aspect*n, 1);
        dxy=min(48,44)/n/aspect/100;
        sxy=smult*dxy;
        rand('state',[0.3085,0.4953,0.0143,0.3137,0.7750,0.8827,0.6275,0.5996,0.3557,0.8033,0.4425,0.3749,0.3086,0.6245,0.0244,0.0309,0.1962,0.2670,0.8672,0.8259,0.3590,0.6446,0.3018,0.6694,0.5783,0.3251,0.0024,0.9082,0.4464,0.0331,0.9344,0.0261,0,0.0000,0.0000]');
        for i=1:length(fens)
            xy=get(fens(i),'xyz');
            if (xy(1)>dxy) & (xy(2)>dxy) & (xy(1)<48-dxy) & (xy(2)<44-dxy)
                xy=[xy(1)+(2*rand(1)-1)/2*sxy,xy(2)+(2*rand(1)-1)/2*sxy,xy(3)];
            end
            fens(i)=set(fens(i),'xyz',xy);
        end
        for i=1:length(fens)
            xy=get(fens(i),'xyz');
            y=xy(2) + (xy(1)/48)*(44 -xy(2)/44*28);
            fens(i)=set(fens(i),'xyz',[xy(1) y xy(3)]);
        end
        if (~isempty( Convertf ))
            [fens,gcells] = Convertf(fens,gcells);
        end
        %             mesh{1}=fens;
        %             mesh{2}=gcells;
        %             drawmesh(mesh); view(2); pause (1)
        prop = property_linel_iso (struct('E',E,'nu',nu));
        mater = mater_defor_neohook(struct('property',prop));
        feb = febf(struct ('mater',mater, 'gcells',gcells, ...
            'integration_rule',integration_rule));

        % Geometry
        geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
        % Define the displacement field
        u   = clone(geom,'u');
        u   = u*0; % zero outfunction five
        % Apply EBC's
        ebc_fenids=fenode_select (fens,struct('box',[0,0,0, 44, 0, 1],'inflate',44/10000));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=[];
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        u   = apply_ebc (u);
        ebc_fenids=(1:length(fens));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=ebc_fenids*0+3;
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        u   = apply_ebc (u);
        % Number equations
        u   = numbereqns (u);
        % Boundary
        bdry_gcells = mesh_bdry(gcells, struct('other_dimension', 1.0));
        icl = gcell_select(fens, bdry_gcells, struct('box', [48,48,44,60,0,1],'inflate',48/1000)) ;
        efeb = febf(struct ('mater',mater,'gcells',bdry_gcells(icl),...
            'integration_rule',Edge_integration_rule));
        % Solve
        % Now comes the nonlinear solution
        tup = 1;
        u = u*0; % zero out the displacement
        utol = 1e-13*get(u, 'neqns');

        if (graphics),gv=graphic_viewer;end
        
%         K = start (sparse_altassem_sysmat, get(u, 'neqns'));
        K = start (sparse_colsol_sysmat, get(u, 'neqns'));
           
        t=0; % time=load magnitude
        incr=1;
        while (incr <= nincr)
            t = t + tup / nincr;
            disp(['Increment ' num2str(incr) ]); % pause
            % Initialization
            u1 = u; % guess
            u1 = apply_ebc(u1);
            du = 0*u; % this will hold displacement increment
            du = apply_ebc(du);
            iter=1;
%             gv=reset(clear(gv,[]),[]);
            %             draw(feb,gv, struct ('x', geom,'u',u, 'facecolor','red'));
            while 1
                prop = property_linel_iso (struct('E',E,'nu',nus(iter)));
                mater = mater_defor_neohook(struct('property',prop));
                feb1=set(feb,'mater',mater);
                %                 feb1=feb;                                           % Make a copy of the state
                fi=force_intensity(struct('magn',[0;t*magn;0]));
                F = start (sysvec, get(u, 'neqns'));
                F = assemble (F, distrib_loads(efeb, geom, u, fi, 2));
                [feb1,evs] = restoring_force(feb1,geom,u1,u);       % Internal forces
                F = assemble (F, evs);
                K = assemble (K, stiffness(feb1, geom, u1,u));
                K = assemble (K, stiffness_geo(feb1, geom, u1,u));
                K = external_decomposition (K,  []);
                % Displacement increment
                du = scatter_sysvec(du, K\F);
                u1 = u1 + du;                                       % increment displacement
                K = reinitialize (K);
                %                 draw(sfeb,gv, struct ('x', geom,'u',u1, 'facecolor','none'));
                %                 pause(1)
                disp(['   It. ' num2str(iter) ': ||du||=' num2str(norm(du))]);
                if (norm(du) < utol) break; end;                    % convergence check
                iter=iter+1;
            end
            [feb,ignore] = restoring_force(feb,geom,u1,u);        % final update
            disp(['    Converged for t=' num2str(t)]); % pause
            u = u1;                                               % update the displacement
            if (graphics)
                gv=reset(clear(gv,[]),[]);
                cmap = jet(16);
                %             draw(sfeb,gv, struct ('x', geom,'u',u, 'facecolor','red'));
                %             draw(sfeb,gv, struct ('x', geom,'u',0*u, 'facecolor','none'));
                fld = field_from_integration_points(feb, geom, u1, [], 'pressure',1);
                nvals=get(fld,'values');%min(nvals),max(nvals)
                nvalsrange=[min(nvals),max(nvals)];
                dcm=data_colormap(struct ('range',nvalsrange, 'colormap',cmap));
                colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, nvals)));
                draw(feb,gv, struct ('x', geom, 'u', u,'colorfield',colorfield, 'shrink',1.0));
                draw(feb,gv, struct ('x', geom, 'u', 0*u,'facecolor','none', 'shrink',1.0));
                % draw(efeb,gv, struct ('x', geom, 'u', 0*u,'facecolor','red', 'shrink',1.0));
                colormap(cmap);
                cbh=colorbar;
                set(cbh,...
                    'Position',[0.815 0.15 0.05 0.7],...
                    'YLim',[0,1],...
                    'YTick',[0,1],...
                    'YTickLabel',{[num2str(nvalsrange(1))],[num2str(nvalsrange(2))]});%{[num2str((min(nvals)))],[num2str((max(nvals)))]}
                set(get(cbh,'XLabel'),'String','\sigma_z');
                pause(0.5);
            end
            incr = incr + 1;
        end
        nl=fenode_select (fens,struct ('box',[48,48,60,60,0,1],'inflate',2/100)) ;
        theutip=gather(u,nl,'values','noreshape');
        theutip =sum(theutip(:,2))/length(nl);
        disp ([' el/edge=' num2str(n) ', displ=' num2str(theutip, 15)])
        h=[h 44/n];
        utip =[utip theutip];

        % Plot
        if graphics
            gv=graphic_viewer;
            gv=reset (gv,struct ([]));
            scale=1;
            cmap = gray;
            cmap=jet;
%             fld = field_from_integration_points(feb, geom, u, [], 'vol_strain', 1);
%             fld = field_from_integration_points(feb, geom, u, [], 'Cauchy', 1);
            fld = field_from_integration_points(feb, geom, u, [], 'pressure', 1);
            nvals=get(fld,'values');%min(nvals),max(nvals)
            %             nvalsrange=[-0.05, -0.02];%[min(nvals),max(nvals)]
            nvalsrange=[min(nvals),max(nvals)];
            dcm=data_colormap(struct ('range',nvalsrange, 'colormap',cmap));
            colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, nvals)));
            draw(feb,gv, struct ('x', geom, 'u', scale*u,'colorfield',colorfield,...
                'edgecolor','white','shrink',1.0));
            xlabel('X','FontName','Times')
            ylabel('Y','FontName','Times')
            set(gca,'FontSize',14);
            set(gca,'FontName','Times')
            % geom3d=combine (geom, 0*fld);
            % u3d=combine (u, 100000000*fld);
            % draw(feb,gv, struct ('x', geom3d, 'u', +scale*u3d,'colorfield',colorfield, 'shrink',1.0));
            colormap(cmap);
            cbh=colorbar;
            set(cbh,'FontSize',14);
            set(cbh,'FontName','Times')
            set(cbh,...
                'Position',[0.625 0.247 0.035 0.51],...
                'YLim',[0,1],...
                'YTick',[0,1],...
                'YTickLabel',{[num2str(nvalsrange(1))],[num2str(nvalsrange(2))]});%{[num2str((min(nvals)))],[num2str((max(nvals)))]}
            %             set(get(cbh,'XLabel'),'String','Volumetric strain');
            view (2)
            %         for i=1:length(fens)
            %             draw(fens(i),gv, struct ('x', geom, 'u', 0*u, 'facecolor','blue'));
            %         end
            
        else
            loglog(h,abs(convutip-utip)/convutip, Style,'lineWIDTH', 3);
            font='Times';
            xlabel ('log(mesh size)')
            ylabel ('log(norm displ error)')
            set(gca,'Position',[0.15 0.15 0.8 0.8]);
            set(gca,'FontSize',14);
            set(gca,'FontName',font)
            l=get(gca,'xlabel');
            set (l,'FontSize',18);
            set(l,'FontName',font)
            l=get(gca,'ylabel');
            set (l,'FontSize',18);
            set(l,'FontName',font)
            hold on; grid on; figure (gcf); pause (2)
        end
    end
    disp(Label);
    disp([h;utip]);
    %     [xestim, beta, residual] = richextrapol(utip(end-2:end),h(end-2:end))
end
