function [h1,se1,h2,se2]=confined_trac
smult=0;
stabfact=0.01;

% nu=0.4;
% convse=7.1044e+005;

% nu=0.49;
% convse=4.1535e+005;
%
nu =0.499;
convse=3.7814e+005;
% %
nu =0.4999;
convse=3.7432e+005;
% %
nu =0.49999;
convse=3.7432e+005;
%
% nu =0.499999;
% convse=3.7390e+005;

% nu =0.4999999999;
% convse=3.7387e+005;


[h,se]=doitt(smult,nu,stabfact, @t3block2d,@feblock_defor_ss_nice, simplex_nq_rule(2))
% % [h1,se1]=doitt(smult,nu,stabfact, @block2d,@feblock_defor_ss_nicer, tensprod_nq_rule(2))
% 
% [h2,se2]=doitt(smult,nu,stabfact, @block2d,@feblock_defor_ss,gauss_rule(2, 2))
% [h1,se1]=doitt(smult,nu,stabfact, @block2d,@feblock_defor_ss_sri,gauss_rule(2, [1,2]))
% loglog(h,abs(convse-se)/convse,'rd--','lineWIDTH', 3); hold on; figure (gcf); pause (1)

return;
end

function [hs,se]=doitt(smult,nu,stabfact, mf,febf,integration_rule)
disp(['Uniform partial traction on confined block: ' func2str(febf)]);
% Parameters:
E=1e7;
graphics=~true;
doeig=~true;
aspect=1;
magn=-5000000;

% Mesh
W=2;
H=1;
hs=[];
se=[];
for n=[2,4,8,16,32,64,128]
% for n=[2,4,5,6,7,8,9,12,16,24]
% for n=[4,5 ,6,7,8,9,12]
%     for n=[14]
    h=W/n;
    [fens,gcells] = mf(W,H, 2*n, aspect*n, 1.0);
    %     [fens,gcells] = targe2_mesh_gen({['curve 1 line ' num2str(0) ' ' num2str(0) ' ' num2str(W) ' ' num2str(0)],...
    %         ['curve 2 line ' num2str(W) ' ' num2str(0) ' ' num2str(W) ' ' num2str(H)],...
    %         ['curve 3 line ' num2str(W) ' ' num2str(H) ' ' num2str(W/2) ' ' num2str(H)],...
    %         ['curve 4 line ' num2str(W/2) ' ' num2str(H) ' ' num2str(0) ' ' num2str(H)],...
    %         ['curve 5 line ' num2str(0) ' ' num2str(H) ' ' num2str(0) ' ' num2str(0)],...
    %         'subregion 1  property 1 boundary 1 2 3 4 5',...
    %         ['m-ctl-point constant ' num2str(h)],...
    %         ['m-ctl-point 2 xy ' num2str(W/2) ' ' num2str(H) ' near ' num2str(h/10) ' influence ' num2str(h/10)],...
    %         }, 1.0);
    %     [fens,gcells] = targe2_mesh_gen({['curve 1 line ' num2str(0) ' ' num2str(0) ' ' num2str(W) ' ' num2str(0)],...
    %         ['curve 2 line ' num2str(W) ' ' num2str(0) ' ' num2str(W) ' ' num2str(H)],...
    %         ['curve 3 line ' num2str(W) ' ' num2str(H) ' ' num2str(W/2) ' ' num2str(H)],...
    %         ['curve 4 line ' num2str(W/2) ' ' num2str(H) ' ' num2str(0) ' ' num2str(H)],...
    %         ['curve 5 line ' num2str(0) ' ' num2str(H) ' ' num2str(0) ' ' num2str(0)],...
    %         'subregion 1  property 1 boundary 1 2 3 4 5',...
    %         ['m-ctl-point constant ' num2str(h)],...
    %         }, 1.0);
    htol=min(W/(2*n),H/(aspect*n));
    dxy=min(W,H)/n/aspect/100;
    sxy=smult*dxy;
    rand('state',[0.3085,0.4953,0.0143,0.3137,0.7750,0.8827,0.6275,0.5996,0.3557,0.8033,0.4425,0.3749,0.3086,0.6245,0.0244,0.0309,0.1962,0.2670,0.8672,0.8259,0.3590,0.6446,0.3018,0.6694,0.5783,0.3251,0.0024,0.9082,0.4464,0.0331,0.9344,0.0261,0,0.0000,0.0000]');
    xy=get(fens,'xyz');
    for i=1:size(xy,1)
        if (xy(i,1)>dxy) & (xy(i,2)>dxy) & (xy(i,1)<W-dxy) & (xy(i,2)<H-dxy)
            xy(i,:)=[xy(i,1)+(2*rand(1)-1)/2*sxy,xy(i,2)+(2*rand(1)-1)/2*sxy];
        end
        fens=set(fens,'xyz',xy);
    end
    %         mesh{1}=fens;
    %         mesh{2}=gcells;
    %         drawmesh(mesh); view (2); pause
    propm = property_linel_iso(struct('E',E,'nu', nu));
        mater = mater_defor_ss_linel_biax (struct ('property',propm,'reduction','strain'));
        feb = febf(struct ('mater',mater, 'gcells',gcells, 'integration_rule',integration_rule,...
            'stabfact',stabfact));
  bdry_gcells = mesh_bdry(gcells, struct('other_dimension', 1));
  icl = gcell_select(fens, bdry_gcells, struct('box', [0 W/2 H H],'inflate',W/1000));
  efeb = feblock_defor_ss (struct ('mater',mater, 'gcells',subset(bdry_gcells,icl),...
    'integration_rule',gauss_rule (1, 2)));
% Geometry
    geom = field(struct ('name',['geom'], 'dim', 2, 'fens',fens));
    % Define the displacement field
    u   = clone(geom,'u');
    u   = u*0; % zero outfunction five
    % Apply EBC's
    % Now the rollers at the bottom
    ebc_fenids=fenode_select (fens,struct('box',[0,W,0, 0],'inflate',htol/10));
    ebc_prescribed=ones(1,length (ebc_fenids));
    ebc_comp=2*ones(1,length (ebc_fenids));
    ebc_val=ebc_fenids*0;
    u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
    % Now the rollers at the sidesa
    ebc_fenids=fenode_select (fens,struct('box',[0, 0,0,H],'inflate',htol/10));
    ebc_prescribed=ones(1,length (ebc_fenids));
    ebc_comp=1*ones(1,length (ebc_fenids));
    ebc_val=ebc_fenids*0;
    u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
    ebc_fenids=fenode_select (fens,struct('box',[W,W,0,H],'inflate',htol/10));
    ebc_prescribed=ones(1,length (ebc_fenids));
    ebc_comp=1*ones(1,length (ebc_fenids));
    ebc_val=ebc_fenids*0;
    u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
    u   = apply_ebc (u);
    % Number equations
    u   = numbereqns (u);
    % Assemble the system matrix
    K = start (sparse_sysmat, get(u, 'neqns'));
    K = assemble (K, stiffness(feb, geom, u));
    % Load
%     ll=line_load(struct ('box',[0 W/2 H H],'inflate',0.0001*H,'magn',[0;magn]));
    F = start (sysvec, get(u, 'neqns'));
%     F = assemble (F, line_loads(feb, geom, u, ll));
    fi=force_intensity(struct('magn',[0;magn]));
F = assemble (F, distrib_loads(efeb, geom, u, fi, 2));
% Solve
    x = K\F;
    u = scatter_sysvec(u, x);
    the_se=x'*get(F, 'vec')/2;
    disp (['n=' num2str(n) ' Strain energy =' num2str(the_se)])
    hs=[hs h];
    se =[se the_se];

    % Plot
    if graphics
        gv=graphic_viewer;
        gv=reset (gv,struct (struct ('limits', [0 W 0 1.25*H])));
    end

    if graphics
        %         gv=graphic_viewer;
        %         gv=reset (gv,struct ([]));
        scale=1;
        cmap = jet;
        fld = field_from_integration_points(feb, geom, u, [], 'vol_strain', 1);
        nvals=get(fld,'values');%min(nvals),max(nvals)
        % nvalsrange=[-0.0001 0.0001];%[min(nvals),max(nvals)]
        nvalsrange=[min(nvals),max(nvals)];
        dcm=data_colormap(struct ('range',nvalsrange, 'colormap',cmap));
        colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, nvals)));
        draw(feb,gv, struct ('x', geom, 'u', +scale*u,'colorfield',colorfield, 'shrink',1.0));
        %         draw(feb,gv, struct ('x', geom, 'u', +scale*u,'facecolor','none', 'shrink',1.0));
        % geom3d=combine (geom, 0*fld);
        % u3d=combine (u, 100000000*fld);
        % draw(feb,gv, struct ('x', geom3d, 'u', +scale*u3d,'colorfield',colorfield, 'shrink',1.0));
        colormap(cmap);
        cbh=colorbar;
        set(cbh,...
            'Position',[0.8 0.1 0.05 0.8],...
            'YLim',[0,1],...
            'YTick',[0,1],...
            'YTickLabel',{[num2str(nvalsrange(1))],[num2str(nvalsrange(2))]});%{[num2str((min(nvals)))],[num2str((max(nvals)))]}
        set(get(cbh,'XLabel'),'String','Volumetric strain');
        title ([func2str(febf)])
        view (2); 
        pause(2); % next eigenvector
        %         for i=1:length(fens)
        %             draw(fens(i),gv, struct ('x', geom, 'u', 0*u, 'facecolor','blue'));
        %         end
        if doeig
            pause(2)
            %% Solve the eigenvibration problem
            neigvs = get(u,'neqns');
            [modes,Omega]=eig(full(a));
            [b,ix]=sort(diag(Omega));

            %% Display the first few eigenvibration modes
            mscale=1;
            w=clone(u,'w'); % make a copy of u
            for i=1:neigvs
                disp(['  Eigenvector ' num2str(i) ' eigenvalue ' num2str(Omega(ix(i),ix(i))) ]);
                w = scatter_sysvec(w, modes(:,ix(i)));
                wv = get(w,'values');
                % display the volumetric strain
                scale=1;
                cmap = gray;
                fld = field_from_integration_points(feb, geom, w, [], 'vol_strain', 1);
                nvals=get(fld,'values');%min(nvals),max(nvals)
                % nvalsrange=[-0.0001 0.0001];%[min(nvals),max(nvals)]
                nvalsrange=[min(nvals),max(nvals)];
                dcm=data_colormap(struct ('range',nvalsrange, 'colormap',cmap));
                colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, nvals)));
                draw(feb,gv, struct ('x', geom, 'u', +scale*w,'colorfield',colorfield, 'shrink',1.0));
                colormap(cmap);
                cbh=colorbar;
                set(cbh,...
                    'Position',[0.8 0.15 0.05 0.7],...
                    'YLim',[0,1],...
                    'YTick',[0,1],...
                    'YTickLabel',{[num2str(nvalsrange(1))],[num2str(nvalsrange(2))]});%{[num2str((min(nvals)))],[num2str((max(nvals)))]}
                set(get(cbh,'XLabel'),'String','Volumetric strain');
                view (2); pause(3)
                wmag = sqrt(wv(:,1).^2+wv(:,2).^2);
                dcm=data_colormap(struct ('range',[min(wmag),max(wmag)], 'colormap',jet));
                colorfield = field(struct ('name',['cf'], 'dim', 3, 'data',map_data(dcm, wmag)));
                for scale=mscale*sin((0:1:42)/21*2*pi)
                    gv=reset (clear (gv),struct ('limits', [-1/40*W 41/40*W -1/40*H 5/4*H]));
                    %         headlight(gv);
                    draw(feb,gv, struct ('x', geom, 'u', scale*w,'colorfield',colorfield));
                    title(['  Eigenvector ' num2str(i) ' eigenvalue ' num2str(Omega(ix(i),ix(i))) ]);
                    pause(0.01);
                end
                title(['  Next eigenvector: type any key' ]);
                clf;
                pause(2); % next eigenvector
            end
        end
    end
end
end
