font='Times';
Legends = {};
Data = {};
Style = {};



Data{end+1}=[
  1./((2:10)+1)
    0.2696    0.1216    0.0444    0.0438    0.0462    0.0499    0.0477    0.0470    0.0450

];Style{end+1}='m^-';Legends{end+1} ='NICE-T4';

Data{end+1}=[
  1./(( 2:10)+1)
    0.3894    0.2799    0.1789    0.2534    0.2233    0.2689    0.2428    0.2725    0.2523
];Style{end+1}='md-';Legends{end+1} ='NICE-H8';


Data{end+1}=[
 1./ (2*(1:5)+1)
 0.3894    0.1633    0.1938    0.2057    0.2097

];Style{end+1}='mh-';Legends{end+1} ='NICE-H27';

% Data{end+1}=[
%  1./(2:6)/2
%  0.2007    0.0955    0.0530    0.0256    0.0205
% ];Style{end+1}='mo--';Legends{end+1} ='NICE-H20';



for j=1:length(Data)
    data=Data{j};
    h=data(1,:); utip=data(2,:);
    loglog(h,utip,Style{j},'lineWIDTH', 2); hold on;
%     loglog(h,abs(utip-uzex)/uzex,Style{j},'lineWIDTH', 3); hold on;
end

set(gca,'XLim', [7e-2, 1]);
% set(gca,'YLim', [1e-5, 1e-0]);
xlabel ('log(1/number of nodes per side)')
ylabel ('log(inf-sup \lambda)')
legend(Legends,'Location','Southeast')
set(gca,'Position',[0.15 0.15 0.5 0.5]);
set_label_defaults
hold on; grid on; figure (gcf);
% saveas(gcf,[mfilename '.png']);
 printeps(gcf,[mfilename '.eps']);
 close  all