
R=5.0;% radius of the sphere, millimeters
nR=3;
Ro=nR*R; % Outer radius, millimeters
nperR=6;%
nlayers=nperR;

tol=R/nperR/1000;

% % %     % Mesh

[fens,gcells]=H8_sphere_n(R,nperR);

bdry_gcells=mesh_bdry(gcells);
clear options
options. facing=true;
options. direction=[1,1,1];
Intl=gcell_select(fens, bdry_gcells, options);
clear gcells
[fens,gcells] = Q4_extrude(fens,subset(bdry_gcells,Intl),nlayers,@(xyz, layer)(R+layer/nlayers*(Ro-R))*xyz/norm(xyz));
connected = find_unconn_fens(fens, gcells);
[fens, new_numbering] =compact_fens(fens, connected);
gcells = renumber_gcell_conn(gcells, new_numbering);


bdry_gcells=mesh_bdry(gcells);

gv=drawmesh({fens,bdry_gcells},'gcells','facecolor','red');
