% Load a Matlab file storing a voxel image.
%
% function [img,dx,dy,dz] = voximg_load(name)
%
% The file is expected to store variables
% img = 3-D image (array), the voxel values  are arbitrary
% dx, dy, dz =dimensions of voxels 
% 
function [img,dx,dy,dz] = voximg_load(name)
     img_data= load (name);
     img=img_data.img;
     dx=img_data.dx;
     dy=img_data.dy;
     dz=img_data.dz;
end