% GL_UNITS.M - a set of global declarations for modules using units
% note: must invoke UNITS.M before these are defined

%base units (American Engineering)
global uFT uSLUG uCOUL uRAN uRAD 

%additional SI base units
global uM uKG uK

%additional CGS base units
global uCM uGM 

%dimensionless prefixes
global MICRO MILLI KILO MEGA GIGA TERA

%angle units
global uDEG uREV

%length 
global uIN uNMI uYD uMM uMILE

%acceleration
global uG

%force
global uLB uNT uOZ

%mass
global uLBM

%time
global uSEC uMIN uHR uDAY uWK uYR uMONTH

%speed
global uKT uMPH

%pressure
global uPSI uPA uBAR uATM uTORR ummHG

%work
global uJ uCAL uERG

%power
global uW uHP

%electrical
global uV uA

%frequency
global uHZ uRPS uRPM

%volume
global uL uGAL

%flow rate
global uGPM

% AECL
global uMACHINE uMEV uFISSION uBUNDLE uBUNDLES_IN_CHANNEL uPINS_IN_CORE 
global uBUNDLES_IN_CORE uPERCENT uDPS uBQ uCURIE uMW uDECAY
global uATOM uMOLE uBARN uNEUTRON uCHANNELS_IN_CORE uREM uSV