integration_rule = gauss_rule(1,4);
pc = get(integration_rule, 'param_coords');
w  = get(integration_rule, 'weights');
npts_per_gcell = get(integration_rule, 'npts');
% transverse load
LI=zeros(4,1);
LJ=zeros(4,1);
for i=1:npts_per_gcell
    xi=pc(i);
    Na = bfun(gcellset_L2,xi);
    N = bfun(gcellset_beam3,xi);
    LI=LI+N*Na(1)*w(i);
    LJ=LJ+N*Na(2)*w(i);
end
LI,LJ
LI+LJ

% axial load
LI=zeros(2,1);
LJ=zeros(2,1);
for i=1:npts_per_gcell
    xi=pc(i);
    Na = bfun(gcellset_L2,xi);
    LI=LI+Na*Na(1)*w(i);
    LJ=LJ+Na*Na(2)*w(i);
end
LI,LJ
LI+LJ