% load([ 'pipe2' ]);
% load([ 'blockswhole1' ]);
%  load([ 'earb1' ]);
% load([ 'smallBlock1' ]);
load([ 'spheres1' ]);
% load([ 'holcub1' ]);

[t,v] = img_to_t4a(img,1);
v(:,1)=dx*v(:,1);
v(:,2)=dy*v(:,2);
v(:,3)=dz*v(:,3);
Initial_number = size(t,1);
nlayers=4;
stretch=1.7;
desired_ts =stretch*dx;

% [t,v] =smoothing(t,v);

for iS1 =1:size(t,1)
    if (tetvol(v(t(iS1,:),:))<0),
        [' Volume: ' num2str(tetvol(v(t(iS1,:),:)))]
    end
end


fens =fenodeset(struct('id',(1:size(v,1)),'xyz',v));
gcells =gcellset_T4(struct('conn',t));
geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
feb = feblock (struct ('mater',[], 'gcells',gcells,...
    'integration_rule', tet_rule (1)));
disp([' Before the volume is = '...
    num2str(measure(feb,geom,inline('1')))])

f = t4_bdry(t);
bv =zeros(size(v,1),1);
for i=1:size(f,1)
    bv(f(i,:)) = true;
end

v2t = v_to_t4_map (size(v,1),t) ;
ts =zeros(size(t,1),1);
ut =zeros(size(t,1),1);
for i=1:size(t,1)
    [edge_lengths,ec] = t4_edge_lengths(v(t(i,:),:));
    ts(i) =max(edge_lengths);
    ut(i) =(sum(bv(t(i,:)))~=0);
end

for layer=1:nlayers
    
    tL = tlist (ts,desired_ts,t,ut);
    nWork = length(tL); Work = 0;
    if (nWork== 0), break;end
    pb=progressbar(['Coarsening: layer ' num2str(layer) ', ' num2str(nWork) ' tetrahedra']);
    while true
        tL = tlist (ts,desired_ts,t,ut);
        nWork =length(tL);
%         pb=progressbar(['Coarsening: layer ' num2str(layer) ', ' num2str(nWork) ' tetrahedra'],pb);
%         pb=progressbar(Work/nWork,pb);
        Change =  ~true;
        for i=1:length(tL)
            ct=tL(i);
            if (t(ct,:) ~= 0)
                for r=1:4
                    ntv(r)=length(v2t{t(ct,r)});
                end
                [mntv,mntvi]=min(ntv);
                ntv(mntvi)=inf;
                [mntv,mntvir]=min(ntv);
                e= [t(ct,mntvi),t(ct,mntvir)];
                [Success,t,v,v2t,ts] = collapse_edge (t,v,v2t,ts,e);
                if (Success)
                    Change = true;
                    break;
                end
            end
        end
        if  (~Change)
            try
            pb=progressbar( 1.0,pb);delete(pb);
            catch,end
            break;
        end
        Work = Work +1; pb=progressbar(Work/nWork,pb);
    end
    %mark layer next to current boundary
    oldbv=bv;
    for i=1:size(bv,1)
        if oldbv(i)
            for j=v2t{i}
                bv(t(j,:))=true;
            end
        end
    end
    for i=1:size(t,1)
        ut(i) =(t(i,1)== 0) || (sum(bv(t(i,:)))~=0);
    end
    length(find(bv~=0))
     desired_ts=desired_ts*stretch;

end

[t,v] =  delete_entities (t,v);

%  [t,v] =smoothing(t,v);

disp( [' Mesh size: initial ' num2str(Initial_number), ', final ' num2str(size(t,1))])
fens =fenodeset(struct('id',(1:size(v,1)),'xyz',v));
gcells =gcellset_T4(struct('conn',t));
geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
feb = feblock (struct ('mater',[], 'gcells',gcells,...
    'integration_rule', tet_rule (1)));
disp([' After the volume is = '...
    num2str(measure(feb,geom,inline('1')))])

for iS1 =1:size(t,1)
    if (tetvol(v(t(iS1,:),:))<0),
        [' Volume: ' num2str(tetvol(v(t(iS1,:),:)))]
    end
end
% %
%
fens =fenodeset(struct('id',(1:size(v,1)),'xyz',v));
gcells =gcellset_T4(struct('conn',t));
validate_mesh(fens, gcells)
