function mkhemisphere
    R= 300;
    Ri= 1;
    thickness =R-Ri;
    nlayers =13;
    [fens,gcells]=Q4_sphere(R,1,thickness);
    function xyz= radially(xyz, layer)
        xyz= (Ri+layer/nlayers*thickness)*xyz/norm(xyz);
    end
    [fens,gcells] = Q4_extrude(fens,gcells,nlayers,@radially);
    
    [fens1,gcells1] = mirror_mesh(fens, gcells, [-1,0,0], [0,0,0]);
    [fens,gcells1,gcells2] = merge_meshes(fens1, gcells1, fens, gcells, Ri/1000);
    gcells=cat(gcells1,gcells2);
    drawmesh({fens,gcells},'gcells','facecolor','red')
    %         function xyz= up(xyz, layer)
    %         xyz= [xyz+(layer^2)*[0.2,-0.2], layer*2.5];
    %     end
    %     [fens,gcells] = extrudeq4(fens,gcells,3,@up);
    %     % drawmesh({fens,gcells},'gcells','nodes','facecolor','red')
    %     drawmesh({fens,gcells},'gcells','facecolor','red')
    % ix =gcell_select(fens,bg,...
    %     struct ('box',[-100 100 -100 0 -100 0],'inflate', 0.5))
    % drawmesh({fens,bg(ix)},'facecolor','red','shrink', 1.0)
end